package com.idea.oa.apply.service;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.idea.oa.apply.mapper.ApplyAddWorkExtendMapper;
import com.idea.oa.apply.mapper.ApplyAddWorkMapper;
import com.idea.oa.apply.model.ApplyAddWork;
import com.idea.oa.apply.model.ApplyAddWorkExample;
import com.idea.oa.apply.model.inout.ApplyAddWorkIn;
import com.rockstar.common.base.BaseService;
import com.rockstar.common.support.Convert;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.util.UUIDUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
public class ApplyAddWorkService implements BaseService<ApplyAddWork, ApplyAddWorkExample> {

    //文件mapper
    @Autowired
    private ApplyAddWorkMapper modelMapper;

    @Autowired
    private ApplyAddWorkExtendMapper applyAddWorkExtendMapper;


    /**
     * 分页查询
     *
     * @return
     */
    public PageInfo<ApplyAddWork> list(Tablepar tablepar, ApplyAddWork model, DateTrans dt) {
        PageHelper.startPage(tablepar.getPageNum(), tablepar.getPageSize());
        List<ApplyAddWork> list = null;//modelMapper.selectByExample(getCondition(model,dt));
        PageInfo<ApplyAddWork> pageInfo = new PageInfo<>(list);
        return pageInfo;
    }

    public Object listAll(ApplyAddWork model, DateTrans dt) {
        List<ApplyAddWork> list = null;//modelMapper.selectByExample(getCondition(model,dt));
        return list;
    }


    @Override
    public int deleteByPrimaryKey(String ids) {
        List<String> lista = Convert.toListStrArray(ids);
        ApplyAddWorkExample example = new ApplyAddWorkExample();
        example.createCriteria().andIdIn(lista);
        return modelMapper.deleteByExample(example);
    }

    @Override
    public ApplyAddWork selectByPrimaryKey(String id) {
        return modelMapper.selectByPrimaryKey(id);
    }

    @Override
    public int updateByPrimaryKeySelective(ApplyAddWork record) {
        return modelMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public int updateByExampleSelective(ApplyAddWork record, ApplyAddWorkExample example) {
        return modelMapper.updateByExampleSelective(record, example);
    }

    @Override
    public int updateByExample(ApplyAddWork record, ApplyAddWorkExample example) {
        return modelMapper.updateByExample(record, example);
    }

    @Override
    public List<ApplyAddWork> selectByExample(ApplyAddWorkExample example) {
        return modelMapper.selectByExample(example);
    }

    @Override
    public long countByExample(ApplyAddWorkExample example) {
        return modelMapper.countByExample(example);
    }


    @Override
    public int deleteByExample(ApplyAddWorkExample example) {
        return modelMapper.deleteByExample(example);
    }

    public int insert(ApplyAddWork record) {
        record.setId(UUIDUtils.middleUUID());
        return insertWithoutId(record);
    }

    public int insertWithoutId(ApplyAddWork record) {
        record.setCreatedAt(new Date());
        return modelMapper.insert(record);
    }

    @Override
    public int insertSelective(ApplyAddWork record) {
        record.setId(UUIDUtils.middleUUID());
        record.setCreatedAt(new Date());
        return modelMapper.insertSelective(record);
    }

    public ApplyAddWorkIn getInfoByFlowMainId(String flowMainId) {
        return applyAddWorkExtendMapper.getInfoByFlowMainId(flowMainId);
    }

    public ApplyAddWorkIn getInfoByFlowMainPushId(String flowMainPushId) {
        return applyAddWorkExtendMapper.getInfoByFlowMainPushId(flowMainPushId);
    }


    public Map<String, Object> getUserInfoByUserId(String userId) {
        Map<String, Object> userInfoByUserId = applyAddWorkExtendMapper.getUserInfoByUserId(userId);
//        if (userInfoByUserId.get("posts") == null) {
//            userInfoByUserId.put("posts", null);
//        }
//
//        if (userInfoByUserId.get("postName") == null) {
//            userInfoByUserId.put("postName", null);
//        }
//
//        if (userInfoByUserId.get("truename") == null) {
//            userInfoByUserId.put("truename", null);
//        }
//
//        if (userInfoByUserId.get("department") == null) {
//            userInfoByUserId.put("department", null);
//        }
//        if (userInfoByUserId.get("deptName") == null) {
//            userInfoByUserId.put("deptName", null);
//        }


        return userInfoByUserId;
    }


}
