package com.idea.oa.flow2.service;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.idea.oa.flow2.mapper.FlowMainLogMapper;
import com.idea.oa.flow2.model.FlowMainLog;
import com.idea.oa.flow2.model.FlowMainLogExample;
import com.rockstar.common.base.BaseService;
import com.rockstar.common.support.Convert;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.util.UUIDUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class FlowMainLogService implements BaseService<FlowMainLog, FlowMainLogExample> {

    //文件mapper
    @Autowired
    private FlowMainLogMapper modelMapper;

    /**
     * 分页查询
     *
     * @return
     */
    public PageInfo<FlowMainLog> list(Tablepar tablepar, FlowMainLog model, DateTrans dt) {
        PageHelper.startPage(tablepar.getPageNum(), tablepar.getPageSize());
        List<FlowMainLog> list = null;//modelMapper.selectByExample(getCondition(model,dt));
        PageInfo<FlowMainLog> pageInfo = new PageInfo<>(list);
        return pageInfo;
    }

   public Object listAll(FlowMainLog model, DateTrans dt) {
        List<FlowMainLog> list = null;//modelMapper.selectByExample(getCondition(model,dt));
        return list;
    }




    @Override
    public int deleteByPrimaryKey(String ids) {
        List<String> lista = Convert.toListStrArray(ids);
        FlowMainLogExample example = new FlowMainLogExample();
        example.createCriteria().andIdIn(lista);
        return modelMapper.deleteByExample(example);
    }

    @Override
    public FlowMainLog selectByPrimaryKey(String id) {
        return modelMapper.selectByPrimaryKey(id);
    }

    @Override
    public int updateByPrimaryKeySelective(FlowMainLog record) {
        return modelMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public int updateByExampleSelective(FlowMainLog record, FlowMainLogExample example) {
        return modelMapper.updateByExampleSelective(record, example);
    }

    @Override
    public int updateByExample(FlowMainLog record, FlowMainLogExample example) {
        return modelMapper.updateByExample(record, example);
    }

    @Override
    public List<FlowMainLog> selectByExample(FlowMainLogExample example) {
        return modelMapper.selectByExample(example);
    }

    @Override
    public long countByExample(FlowMainLogExample example) {
        return modelMapper.countByExample(example);
    }


    @Override
    public int deleteByExample(FlowMainLogExample example) {
        return modelMapper.deleteByExample(example);
    }

    public int insert(FlowMainLog record){
        record.setId(UUIDUtils.middleUUID());
        return insertWithoutId(record);
    }

    public int insertWithoutId(FlowMainLog record){
        return modelMapper.insert(record);
    }

    @Override
    public int insertSelective(FlowMainLog record) {
        record.setId(UUIDUtils.middleUUID());
        record.setCreatedAt(new Date());
        return modelMapper.insertSelective(record);
    }

    public FlowMainLog selectLastOneByFlowMainId(String flowMainId) {
        FlowMainLogExample example = new FlowMainLogExample();
        example.setOrderByClause("created_at desc limit 1");
        example.createCriteria().andFlowMainIdEqualTo(flowMainId);
        List<FlowMainLog> flowMainLogs = modelMapper.selectByExample(example);
        if (flowMainLogs.isEmpty()){
            return null;
        }else{
            return flowMainLogs.get(0);
        }

    }
}
