package com.idea.paymentManagement.controller;

import com.github.pagehelper.PageInfo;
import com.idea.customerManagement.dto.ContractManageDto;
import com.idea.paymentManagement.model.MaintenanceFundsManagement;
import com.idea.paymentManagement.service.MaintenanceFundsManagementService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.util.StringUtils;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping(value = "MaintenanceFundsManagementController")
@Api(tags = "专项维修资金")
public class MaintenanceFundsManagementController extends BaseController {

    @Autowired
    private MaintenanceFundsManagementService modelService;

    /**
     * 分页
     * @param tablepar
     * @param model
     * @param dt
     * @return
     */
    @PostMapping(value = "list",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, ContractManageDto model, DateTrans dt){
        PageInfo<ContractManageDto> page= modelService.listByModel(tablepar,model,dt);
        TableSplitResult<ContractManageDto> result = new TableSplitResult<ContractManageDto>(page.getPageNum(), page.getTotal(), page.getList());
        return  result;
    }

    /**
     * 收款登记
     * @param model
     * @return
     */
    @PostMapping(value = "add",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(MaintenanceFundsManagement model){
        int result = modelService.add(model);
        return result(result);
    }

    /**
     * 查询对应的银行
     * @param contractId
     * @return
     */
    @PostMapping(value = "getBankByFloor",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getBankByFloor(String contractId) {
        if(!StringUtils.isNotEmpty(contractId)){
            return AjaxResult.error(503, "参数不能为空");
        }
        return modelService.getBankByFloor(contractId);
    }

    @PostMapping(value = "getById",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getById(String id) {

        return modelService.getById(id);
    }





}
