package com.idea.paymentManagement.controller;

import com.idea.paymentManagement.model.RefundDetail;
import com.idea.paymentManagement.dto.RefundDetailDto;
import com.idea.paymentManagement.service.RefundDetailService;
import com.rockstar.common.base.BaseController;
import com.rockstar.frame.model.extend.DateTrans;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

@Controller
@RequestMapping(value = "RefundDetailController")
@Api(tags = "退款管理")
public class RefundDetailController extends BaseController {

    @Autowired
    private RefundDetailService modelService;

    /**
     * 根据轮号客户id 查询已收 部分收款 完全收款
     * @param customerManagementId
     * @return
     */
    @PostMapping(value = "getByCustomerManagementId",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public List<RefundDetailDto> getByCustomerManagementId(String customerManagementId, String houseId){

        List<RefundDetailDto> result = modelService.getByCustomerManagementId(customerManagementId,houseId);
        return result;
    }

    @PostMapping(value = "listAll",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listAll(RefundDetail model, DateTrans dt){
        return  modelService.listAll(model,dt);
    }


}
