package com.idea.paymentManagement.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Data
public class PayLog implements Serializable {
    private String id;

    private String houseId;

    private String businessId;

    private String contractId;

    private String customerManagementId;

    private Integer payType;

    private Integer contentType;

    private String bankName;

    private String bankBranchName;

    private String bankNumber;

    private BigDecimal payMoney;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date payTime;

    private Integer paymentMethod;

    private Integer status;

    private Integer paymentStatus;

    private String serialNumber;

    private String remark;

    private String createdBy;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date createdAt;

    private String updatedBy;

    private Date updatedAt;

    private String fileList;

    private String ncJson;

    private Integer ncSubmitStatus;

    private Date ncSubmitDate;

    private String ncSubmitName;

    private Integer isHide;

    private static final long serialVersionUID = 1L;


}